import sqlite3 as lite
import sys
import bd.utiles as utiles

class EntornoBDMapper(object):

	def getAll(self):
		con = utiles.connectBD()
		
		with con:
			con.row_factory = lite.Row

			cur = con.cursor() 
			cur.execute("SELECT * FROM entorno")

			rows = cur.fetchall()
			
			entornosList = []
			for row in rows:
				entorno = self.__mapToObject(row)
				entornosList.append(entorno)

			return entornosList


	def putObject(self, obj):
		
		con = utiles.connectBD()
		
		try:
			cur = con.cursor()
			
			sql = "INSERT INTO entorno\
					VALUES ('%s', %s, '%s');" % (
						obj.nombre, 'NULL', obj.estado)
			
			cur.execute(sql)
			
			for perfil in obj.perfiles:
				sql = "INSERT INTO ent_per\
						VALUES ('%s', '%s');" % (
							obj.nombre, perfil)
			
				cur.execute(sql)	
			
			con.commit()
			
		except lite.IntegrityError, e:
			raise
		finally:
			if con:
				con.close()


	def getObject(self, oid):
		
		con = utiles.connectBD()
		
		with con:
			con.row_factory = lite.Row

			cur = con.cursor()
			cur.execute("SELECT * FROM entorno WHERE nombre='%s'" % (oid))
			
			row = cur.fetchone()
			entorno = self.__mapToObject(row)
			
			cur.execute("SELECT * FROM ent_per WHERE nombre_ent='%s'" % (oid))
			rows = cur.fetchall()
			
			entorno.perfiles = []
			for row in rows:
				entorno.perfiles.append(row["nombre_per"])
			
			return entorno
		
			
	def deletePerfil(self, obj, nombrePerfil):

		con = utiles.connectBD()

		with con:
			cur = con.cursor()

			sql= "DELETE FROM ent_per WHERE nombre_ent='%s' AND nombre_per='%s';" % (
				obj.nombre, nombrePerfil)

			cur.execute(sql)
			
			
	def updateObject(self, obj):
	
		con = utiles.connectBD()

		try:
			cur = con.cursor()

			sql= "UPDATE entorno\
				SET nombre='%s'\
				WHERE nombre='%s';" % (
			obj.nuevoNombre, obj.nombre)

			cur.execute(sql)
		
			for nombrePerfil in obj.perfiles:
				sql= "INSERT INTO ent_per VALUES ('%s', '%s');" % (obj.nuevoNombre, nombrePerfil)
				cur.execute(sql)
			
			con.commit()
			
		except lite.IntegrityError, e:
			raise
		finally:
			if con:
				con.close()
				

	def __mapToObject(self, row):
		entorno = Entorno()
		entorno.nombre = row["nombre"]
		entorno.ubicacionImg = row["ubicacionImg"]
		entorno.estado = row["estado"]
		return entorno
	
from model.entorno import Entorno
