import view.errormsg as errormsg
from sqlite3 import IntegrityError
from ctrl.gestorWorkingDir import GestorWorkingDir
from ctrl.gestorExecScript import GestorExecScript
from view.winNuevoEntorno import WinNuevoEntorno
from view.winConfigEntorno import WinConfigEntorno
from model.entorno import Entorno
from model.perfil import Perfil
from model.modelo import Modelo
import model.utiles as utilesModelo
import view.errormsg as errormsg
import logging
import bd.comunesBD as comunesBD

class GestorEntorno(object):

	__paginaEntorno = None
	__winNuevoEntorno = None
	__winConfigEntorno = None

	def __init__(self, pe):
		self.__paginaEntorno = pe

	def nuevo(self):
		self.__winNuevoEntorno = WinNuevoEntorno(self)

	def config(self, OID):
		entorno = Entorno.getObject(OID)
		self.__winConfigEntorno = WinConfigEntorno(self, entorno)		

	def almacenaEntorno(self, data):
		entorno = Entorno()

		entorno.nombre = data["nombre"]
		entorno.perfiles = data["perfiles"]
		entorno.estado = utilesModelo.estado_values[1]
		
		#validacion es una tupla(boolean, mensaje_eror).
		validacion = entorno.checkData()
		if not validacion[0]:
			try:
				entorno.putObject()
				
				self.__paginaEntorno.actualiza()
				self.__winNuevoEntorno.terminar()
				
				logging.info('Se ha creado un nuevo entorno: %s' % (entorno.nombre))
			except IntegrityError:
				self.__winNuevoEntorno.errorValidacion(errormsg.entornoExiste_err)
		else:
			self.__winNuevoEntorno.errorValidacion(validacion[1])
			
	def actualizaEntorno(self, data):
		entorno = Entorno()

		entorno.nombre = data["nombre"]
		entorno.nuevoNombre = data["nuevoNombre"]
		entorno.perfiles = data["perfilesNuevos"]
		
		#validacion es una tupla(boolean, mensaje_eror).
		validacion = entorno.checkData()
		
		if not validacion[0]:
			try:
				for perfil in data["perfilesEliminados"]:		
					entorno.deletePerfil(perfil)
								
				entorno.updateObject()
				
				self.__paginaEntorno.actualiza()
				self.__winConfigEntorno.terminar()
				
			except IntegrityError:
				self.__winConfigEntorno.errorValidacion(errormsg.entornoExiste_err)
		else:
			self.__winConfigEntorno.errorValidacion(validacion[1])

	def generaEntorno(self, OID, tam):
		ent = Entorno.getObject(OID)
		per = Perfil.getObject(ent.perfiles[0])
		mod = Modelo.getObject(per.modelo)
		
		gs = GestorExecScript()
		gs.execGenEnt(mod.nombre, ent.nombre, ent.perfiles, tam)
	
	def desactivar(self, nombreEntorno):
		self.__paginaEntorno.actualiza()
	
