import view.errormsg as errormsg
from sqlite3 import IntegrityError
from ctrl.gestorWorkingDir import GestorWorkingDir
from ctrl.gestorExecScript import GestorExecScript
from view.winNuevoPerfil import WinNuevoPerfil
from view.winConfigPerfil import WinConfigPerfil
from model.perfil import Perfil
import model.utiles as utiles
import view.errormsg as errormsg
import logging

class GestorPerfil(object):

	__paginaPerfil = None
	__winNuevoPerfil = None
	__winConfigPerfil = None

	def __init__(self, pf):
		self.__paginaPerfil = pf

	def nuevo(self):
		self.__winNuevoPerfil = WinNuevoPerfil(self)

	def config(self, OID):
		perfil = Perfil.getObject(OID)
		self.__winConfigPerfil = WinConfigPerfil(self, perfil)		

	def almacenaPerfil(self, data):
		perfil = Perfil()

		perfil.nombre = data["nombre"]
		perfil.modelo = data["modelo"]
		perfil.estado = utiles.estado_values[1]
		
		#validacion es una tupla(boolean, mensaje_eror).
		validacion = perfil.checkData()
		if not validacion[0]:
			try:
				perfil.putObject()
				
				for paquete in data["paquetes"]:
					dict = {"nombre": paquete, "perfil": perfil.nombre}
					perfil.putPaquete(dict)
				
				self.__paginaPerfil.actualiza()
				self.__winNuevoPerfil.terminar()
								
				logging.info('Se ha creado un nuevo perfil: %s' % (perfil.nombre))
			except IntegrityError:
				self.__winNuevoPerfil.errorValidacion(errormsg.perfilExiste_err)
		else:
			self.__winNuevoPerfil.errorValidacion(validacion[1])
			
			
	def actualizaPerfil(self, data):
		perfil = Perfil()

		perfil.nombre = data["nombre"]
		perfil.modelo = data["modelo"]
		perfil.nuevoNombre = data["nuevoNombre"]
		
		#validacion es una tupla(boolean, mensaje_eror).
		validacion = perfil.checkData()
		if not validacion[0]:
			try:
				
								
				for paquete in data["nombrePaquetesNuevos"]:
					dict = {"nombre": paquete, "perfil": perfil.nuevoNombre}
					perfil.putPaquete(dict)

				for paquete in data["idPaquetesEliminados"]:
					perfil.deletePaquete(paquete)
				
				perfil.updateObject()
					
				self.__paginaPerfil.actualiza()
					
				self.__winConfigPerfil.terminar()
												
				logging.info('Se ha creado un nuevo perfil: %s' % (perfil.nombre))
				
			except IntegrityError:
				self.__winConfigPerfil.errorValidacion(errormsg.perfilExiste_err)
		else:
			self.__winConfigPerfil.errorValidacion(validacion[1])
		

			
		

		

