#!/bin/sh
limpia_directorio()
{
	lb clean noauto ${@}
	rm -f config/binary
	rm -f config/bootstrap
	rm -f config/chroot
	rm -f config/common
	rm -f config/source
	rm -f binary.log
	echo "ejecutado script clean noauto"
}

readParams() {
	eval $( awk -F "=" '
	NF >= 2 && $0 !~ /^[:space:]*#/ {
	   variable = $1;
	   value    = $2;
	   print variable "=" value; 
	}
	' ${1} )
}

MOD_DIR=`dirname ${1}`
LB=/usr/bin/lb

readParams ${1}

cd ${MOD_DIR}
pwd
limpia_directorio

#PRY_BOOTAPPEND="persistent persistent-subtext=perfil"
PRY_BOOTAPPEND="${PRY_BOOTAPPEND} locales=es_ES.UTF-8"
PRY_BOOTAPPEND="${PRY_BOOTAPPEND} keyboard-layout=es"

#PRY_PACKAGES="apache2 php5"

LBCONFIG_OPTS="auto"
LBCONFIG_OPTS="${LBCONFIG_OPTS} --architecture ${MOD_ARQ}"
#LBCONFIG_OPTS="${LBCONFIG_OPTS} --linux-flavours 686"
LBCONFIG_OPTS="${LBCONFIG_OPTS} --binary-images usb-hdd"
LBCONFIG_OPTS="${LBCONFIG_OPTS} --hostname ${MOD_HOSTNAME}"
LBCONFIG_OPTS="${LBCONFIG_OPTS} --username ${MOD_USERNAME}"
LBCONFIG_OPTS="${LBCONFIG_OPTS} --bootstrap-flavour ${MOD_INSTALACION}"
LBCONFIG_OPTS="${LBCONFIG_OPTS} --packages-lists ${MOD_DESKTOP}-desktop"
#Configuracion de escritorios.
#if [ ${MOD_DESKTOP} != 'Ninguno' ]
#then
#	LBCONFIG_OPTS="${LBCONFIG_OPTS} --tasks ${MOD_DESKTOP}-desktop desktop standard laptop spanish spanish-desktop #spanish-${MOD_DESKTOP}-desktop"
#	 echo 'tasksel tasksel/desktop multiselect ${MOD_DESKTOP}' >> config/preseed/my.preseed.chroot
#fi

# 2. Crear la configuración básica (ver lb config)
#

${LB} config ${LBCONFIG_OPTS} --bootappend-live "${PRY_BOOTAPPEND}"
#--packages "${PRY_PACKAGES}"

# 3. Ejecutamos el build para crear la imagen del sistema

${LB} build 2>&1 | tee binary.log
