#!/bin/sh

Arguments ()
{

	ARGUMENTS="$(getopt --longoptions snap:,tam:,entorno:,imagen: --name="liveUva" --options s:t:e:i: --shell sh -- "${@}")"

	if [ "${?}" != "0" ]
	then
		echo "terminating" >&2
		exit 1
	fi

	eval set -- "${ARGUMENTS}"	
	echo ${@}
	
	while true
	do
		case "${1}" in
			-s|--snap)
				SNAPS="${2}"
				shift 2
				echo "snap"
				;;

			-e|--entorno)
				ENT="${2}"
				shift 2
				;;

			-t|--tam)
				TAM="${2}"
				shift 2
				;;

			-i|--imagen)
				IMG="${2}"
				shift 2
				;;

			--)
				shift
				break
				;;

			*)
				echo "internal error"
				exit 1
				;;
		esac
	done
}

Arguments "${@}"

echo "${SNAPS}"
echo "${TAM}"
echo "${DEST}"

TDISCO=$((${TAM} * 1024))
TIMG=`ls -l "${IMG}" | cut -d " " -f 5`

# Crear el disco
dd if=/dev/zero of="${ENT}" bs=1024 count=${TDISCO}

# Grabar la imagen al principio del disco.
losetup -d /dev/loop7
losetup /dev/loop7 "${ENT}"
dd if="${IMG}" of=/dev/loop7

# Crear un sistema de ficheros en el espacio restante.
parted "${ENT}" unit B mkpart p "${TIMG}"B 100% -s
losetup -d /dev/loop6
losetup -o "${TIMG}" /dev/loop6 "${ENT}"
mkfs.ext2 -L SNAPTS /dev/loop6

mkdir /mnt/liveUva_tmp
mount /dev/loop6 /mnt/liveUva_tmp

eval set "${SNAPS}"
for snap in "${@}"
do
	cp -r "${snap}" /mnt/liveUva_tmp
done

# liberar los loop y el fichero de montaje temporal.
umount /mnt/liveUva_tmp
losetup -d /dev/loop6
losetup -d /dev/loop7
rm -rf /mnt/liveUva_tmp


