# -*- coding: utf-8 -*-
import view.errormsg as errormsg
import model.utiles as utiles
from sqlite3 import IntegrityError
#Constantes
arquitectura_values = ["i386", "amd64"]
fInicial_values = ["minimal", "standard"]
escritorio_values = ["gnome", "kde", "lxde", "xfce"]

class Modelo(object):

	def __init__(self):
		self.__nombre=""
		self.__arquitectura=""
		self.__instalacion=""
		self.__entornoGrafico=""
		self.__ubicacionImg=""
		self.__username=""
		self.__hostname=""
		self.__estado=""
		self.__nuevoNombre=None # Solo se utiliza cuando hay que cambiar el nombre.
	
	def __getNombre(self):
		return self.__nombre

	def __getArquitectura(self):
		return self.__arquitectura
		
	def __getInstalacion(self):
		return self.__instalacion

	def __getEntornoGrafico(self):
		return self.__entornoGrafico
		
	def __getUbicacionImg(self):
		return self.__ubicacionImg

	def __getUsername(self):
		return self.__username

	def __getHostname(self):
		return self.__hostname

	def __getEstado(self):
		return self.__estado

	def __getNuevoNombre(self):
		return self.__nuevoNombre

	def __setNombre(self, nombre):
		self.__nombre = nombre

	def __setArquitectura(self, arquitectura):
		self.__arquitectura = arquitectura
		
	def __setInstalacion(self, instalacion):
		self.__instalacion = instalacion

	def __setEntornoGrafico(self, entornoGrafico):
		self.__entornoGrafico = entornoGrafico
		
	def __setUbicacionImg(self, ubicacionImg):
		self.__ubicacionImg = ubicacionImg

	def __setUsername(self, username):
		self.__username = username

	def __setHostname(self, hostname):
		self.__hostname = hostname

	def __setEstado(self, estado):
		self.__estado = estado
		
	def __setNuevoNombre(self, nuevoNombre):
		self.__nuevoNombre = nuevoNombre		
		
	nombre = property(fget=__getNombre, fset=__setNombre)
	arquitectura = property(fget=__getArquitectura, fset=__setArquitectura)
	instalacion = property(fget=__getInstalacion, fset=__setInstalacion)
	entornoGrafico = property(fget=__getEntornoGrafico, fset=__setEntornoGrafico)
	ubicacionImg = property(fget=__getUbicacionImg, fset=__setUbicacionImg)
	username = property(fget=__getUsername, fset=__setUsername)
	hostname = property(fget=__getHostname, fset=__setHostname)
	estado = property(fget=__getEstado, fset=__setEstado)
	nuevoNombre = property(fget=__getNuevoNombre, fset=__setNuevoNombre)
	
	@classmethod
	def getAll(cls):
		facade = PersistenceFacade()
		return facade.getall(cls.__name__)
		
		
	@classmethod
	def getObject(cls, OID):
		facade = PersistenceFacade()
		return facade.getObject(cls.__name__, OID)


	def putObject(self):
		try:
			facade = PersistenceFacade()
			facade.putObject(self)
		except IntegrityError:
			raise
	
	def updateObject(self):
		try:
			facade = PersistenceFacade()
			facade.updateObject(self)
		except IntegrityError:
			raise
		
	def checkData(self):
		mssg = errormsg.intro_err
		err = 0
		if not(self.nombre.isalnum()) or utiles.isEmpty(self.nombre):
			mssg += errormsg.nombre_err + '\n'
			err = 1
		if self.nuevoNombre is not None:
			if not(self.nuevoNombre.isalnum()) or utiles.isEmpty(self.nuevoNombre):
				mssg += errormsg.nombre_err + '\n'
				err = 1
		if not(self.username.isalnum()) or utiles.isEmpty(self.username): #or self.username.find(" "):
			mssg += errormsg.username_err + '\n'
			err = 1
		if not(self.hostname.isalnum()) or utiles.isEmpty(self.hostname): #or self.hostname.find(" "):
			mssg += errormsg.hostname_err + '\n'
			err = 1
		return (err, mssg)
				
from bd.persistenceFacade import PersistenceFacade
