import sys
import pygtk
pygtk.require("2.0")
import gtk
import pprint
from view.paginaModelo import PaginaModelo
from view.paginaPerfil import PaginaPerfil
from view.paginaEntorno import PaginaEntorno
from ctrl.gestorWorkingDir import GestorWorkingDir
import ctrl.utiles as utilesCtrl
import view.utiles as utilesView
import view.errormsg as errormsg
import os

class Inicio(object):
	"""El indice que corresponde a cada pagina en el notebook."""
	__INICIO = "frInicio"
	__MODELOS = "frModelo"
	__PERFILES = "frPerfil"
	__ENTORNOS = "frEntorno"
	__DISTRIBS = "frDistribucion"
	
	__paginaModelo = None
	__paginaPerfil = None
	__paginaEntorno = None
	__paginaDistribucion = None
	__notebook = None

	def __init__(self):		
	
		filename = utilesView.INICIO_GL
		self.__builder = gtk.Builder()
		self.__builder.add_from_file(filename)
		self.__builder.connect_signals(self)
		
		self.__dlgWorkdir = self.__builder.get_object("dlgWorkDir")
		self.__dlgConfirmWorkdir = self.__builder.get_object("dlgConfirmWorkdir")
		self.__dlgConfirmWorkdir.set_markup(errormsg.confirmaWorkdir)
		self.__fchooserWorkdir = self.__builder.get_object("fchooserWorkdir")
		self.__notebook = self.__builder.get_object("ntbGestion")

		self.__notebook.set_current_page(0)
		
		# Si esta establecido el workdir, se carga. Si no, oculta las tabs del notebook.
		gw = GestorWorkingDir()
		wd = gw.getWorkingdir()
		if wd is not None:
			self.__fchooserWorkdir.set_filename(wd)
			gw.iniciaLogger()

		if wd is None:
			self.__notebook.set_show_tabs(False)
		
		
		mainWin = self.__builder.get_object("winPrincipal")
		mainWin.show()

	def on_ntbGestion_switchPage(self, notebook, page, page_num):
	
		child = notebook.get_nth_page(page_num)
		nombre = gtk.Buildable.get_name(child)

		if (nombre == self.__MODELOS):
			if (self.__paginaModelo is None):
				self.__paginaModelo = PaginaModelo(self.__builder)
			self.__paginaModelo.actualiza()

		elif (nombre == self.__PERFILES):
			if (self.__paginaPerfil is None):
				self.__paginaPerfil = PaginaPerfil(self.__builder)

			self.__paginaPerfil.actualiza()

		elif (nombre == self.__ENTORNOS):
			if (self.__paginaEntorno is None):
				self.__paginaEntorno = PaginaEntorno(self.__builder)
			self.__paginaEntorno.actualiza()

		elif (nombre == self.__DISTRIBS):
			if (self.__paginaDistribucion is None):
				self.__paginaDistribucion = PaginaDistribucion(self.__builder)
			self.__paginaDistribucion.actualiza()

	def on_butWorkdir_clicked(self, widget):
		self.__dlgWorkdir.show()


	"""		Dialogo para establecer el workdir		"""
	def on_butEstablecerWorkdir_clicked(self, widget):
		self.__dlgConfirmWorkdir.show()
				
	def on_butVolverWorkdir_clicked(self, widget):
		self.__dlgWorkdir.hide()
		
		
	"""		Dialogo de confirmacion para establecer el workdir		"""
	def on_butConfirmaWorkdir_clicked(self, widget):
		path = self.__fchooserWorkdir.get_filename()
		if not ( path is None ):
			gw = GestorWorkingDir()
			gw.estableceWorkdir(path, self)
			self.__dlgConfirmWorkdir.hide()
			self.__dlgWorkdir.hide()
		else:
			self.__dlgConfirmWorkdir.hide()
		
	def showTabs(self):	
		self.__notebook.set_show_tabs(True)		
					
	def on_butRechazaWorkdir_clicked(self, widget):
		self.__dlgConfirmWorkdir.hide()
			
	def on_winPrincipal_destroy(self, widget):
		gtk.main_quit()


