import pygtk
pygtk.require("2.0")
import gtk

from model.entorno import Entorno
import model.utiles as utilesModel
import view.utiles as utilesView
from ctrl.gestorEntorno import GestorEntorno
import view.errormsg as errormsg

class PaginaEntorno(object):

	__builder = None
	__gestorEntorno = None
	__tvEntorno = None

	def __init__(self, bld):
	
		self.__builder = bld
		self.__gestorEntorno = GestorEntorno(self)		
		self.__connectSignals()	
		self.__tvEntorno = self.__builder.get_object("tvEntorno")
		
		filename = utilesView.PAGINA_ENTORNO_GL
		
		self.__builderPagina = gtk.Builder()
		self.__builderPagina.add_from_file(filename)
		self.__builderPagina.connect_signals(self)

		self.__dlgConfirmacionDesactivar = self.__builderPagina.get_object("dlgConfirmacionDesactivar")
		self.__dlgConfirmacionGenEnt = self.__builderPagina.get_object("dlgConfirmacionGenEnt")
		
		# Para el dialogo donde se introduce el tamanyo del entorno.
		self.__dlgTam = self.__builderPagina.get_object("dlgTam")
		self.__ntryTam = self.__builderPagina.get_object("ntryTam")
		self.__ntryTam.set_text('0')
		
		# Establecer los mensajes de los dialogos
		self.__dlgConfirmacionDesactivar.set_markup(errormsg.desactivarEntorno_msg)
		self.__dlgConfirmacionGenEnt.set_markup(errormsg.generarEntorno_msg)


	def actualiza(self):
		

		listStore = self.__builder.get_object("lstoreEntorno")
	
		listStore.clear()
		entornos = Entorno.getAll()
		for entorno in entornos:
			if(entorno.estado == utilesModel.estado_values[1]):
				listStore.append(['%s' % entorno.nombre])


		
	"""		operaciones sobre la seleccion actual		"""	
	
	def on_butEntConfig_clicked(self, widget):

		nombreEntorno = utilesView.tv_getSelection(self.__tvEntorno, 0)
		if not(nombreEntorno is None):
			self.__gestorEntorno.config(nombreEntorno)

	"""		Desactivar el entorno seleccionado		"""
	def on_butEntDesactivar_clicked(self, widget):
		nombreEntorno = utilesView.tv_getSelection(self.__tvEntorno, 0)
		if not(nombreEntorno is None):
			self.__dlgConfirmacionDesactivar.show()
			
	def on_butTerminarDesactivar_clicked(self, widget):
		nombreEntorno = utilesView.tv_getSelection(self.__tvEntorno, 0)
		if not(nombreEntorno is None):
			self.__gestorEntorno.desactivar(nombreEntorno)
			self.__dlgConfirmacionDesactivar.hide()

	def on_butVolverDesactivar_clicked(self, widget):
		self.__dlgConfirmacionDesactivar.hide()

	"""		Generar el entorno seleccionado		"""
	def on_butGenEntorno_clicked(self, widget):
		
		nombreEntorno = utilesView.tv_getSelection(self.__tvEntorno, 0)
		if not(nombreEntorno is None):
			self.__dlgConfirmacionGenEnt.show()
			
	def on_butTerminarGenEnt_clicked(self, widget):
		nombreEntorno = utilesView.tv_getSelection(self.__tvEntorno, 0)
		if not(nombreEntorno is None):
			self.__dlgConfirmacionGenEnt.hide()
			self.__dlgTam.show()
		
	def on_butVolverGenEnt_clicked(self, widget):
		self.__dlgConfirmacionGenEnt.hide()
		

	"""		dialogo para recoger el tamanyo del entorno		"""
	def on_butAceptarTam_clicked(self, widget):
		nombreEntorno = utilesView.tv_getSelection(self.__tvEntorno, 0)
		if not(nombreEntorno is None):
			tam = self.__ntryTam.get_text()
			if tam.isdigit() and (int(tam) > 0):
				self.__gestorEntorno.generaEntorno(nombreEntorno, int(tam))
				self.__dlgTam.hide()
	
	
	def on_butSalirTam_clicked(self, widget):
		self.__dlgTam.hide()
	

	"""		otras operaciones			"""
	
	def on_butEntNuevo_clicked(self, widget):
		self.__gestorEntorno.nuevo()
	
	
	def __connectSignals(self):
	
		self.__butEntConfig = self.__builder.get_object("butEntConfig")
		self.__butEntConfig.connect("clicked", self.on_butEntConfig_clicked)

		self.__butEntNuevo = self.__builder.get_object("butEntNuevo")
		self.__butEntNuevo.connect("clicked", self.on_butEntNuevo_clicked)

		self.__butEntDesactivar = self.__builder.get_object("butEntDesactivar")
		self.__butEntDesactivar.connect("clicked", self.on_butEntDesactivar_clicked)
		
		self.__butGenEntorno = self.__builder.get_object("butGenEnt")
		self.__butGenEntorno.connect("clicked", self.on_butGenEntorno_clicked)		
