import pygtk
pygtk.require("2.0")
import gtk

from model.perfil import Perfil
import model.utiles as utilesModel
from ctrl.gestorPerfil import GestorPerfil
import view.utiles as utilesView
import view.errormsg as errormsg

class PaginaPerfil(object):

	__builder = None
	__gestorPerfil = None
	__tvPerfil = None
	__dlgConfirmacionDesactivar = None

	def __init__(self, bld):
	
		self.__builder = bld
		self.__gestorPerfil = GestorPerfil(self)		
		self.__connectSignals()	
		self.__tvPerfil = self.__builder.get_object("tvPerfil")
		
		filename = utilesView.PAGINA_PERFIL_GL
		self.__builderPagina = gtk.Builder()
		self.__builderPagina.add_from_file(filename)
		self.__builderPagina.connect_signals(self)

		self.__dlgConfirmacionDesactivar = self.__builderPagina.get_object("dlgConfirmacionDesactivar")
		
		# Establecer los mensajes de los dialogos
		self.__dlgConfirmacionDesactivar.set_markup(errormsg.desactivarPerfil_msg)
		
	def actualiza(self):

		listStore = self.__builder.get_object("lstorePerfil")
		
		listStore.clear()
		perfiles = Perfil.getAll()
		for perfil in perfiles:
			if(perfil.estado == utilesModel.estado_values[1]):
				listStore.append(['%s' % perfil.nombre])


		
		
	""" Operaciones sobre la seleccion actual """	
	def on_butPerConfig_clicked(self, widget):

		nombrePerfil = utilesView.tv_getSelection(self.__tvPerfil, 0)
		if not(nombrePerfil is None):
			self.__gestorPerfil.config(nombrePerfil)


	"""		Desactivar el perfil seleccionado		"""
	def on_butPerDesactivar_clicked(self, widget):
		nombrePerfil = utilesView.tv_getSelection(self.__tvPerfil, 0)
		if not(nombrePerfil is None):
			self.__dlgConfirmacionDesactivar.show()
			
	def on_butTerminarDesactivar_clicked(self, widget):
		self.__gestorPerfil.desactivar(nombrePerfil)

	def on_butVolverDesactivar_clicked(self, widget):
		self.__dlgConfirmacionDesactivar.hide()

		
	""" otras operaciones """
	def on_butPerNuevo_clicked(self, widget):
		self.__gestorPerfil.nuevo()
	
	
	def __connectSignals(self):
	
		self.__butPerConfig = self.__builder.get_object("butPerConfig")
		self.__butPerConfig.connect("clicked", self.on_butPerConfig_clicked)

		self.__butPerNuevo = self.__builder.get_object("butPerNuevo")
		self.__butPerNuevo.connect("clicked", self.on_butPerNuevo_clicked)

		self.__butPerDesactivar = self.__builder.get_object("butPerDesactivar")
		self.__butPerDesactivar.connect("clicked", self.on_butPerDesactivar_clicked)


